close all
clear
clc
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% mohammad.alaee@uni.lu
% mmalaee@yahoo.com
% 30.03.2019
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%% Initialization
thr                 = 1e-5;
L                   = 2;
trials              = 5;
P                   = (1:13);
codeLengths         = 2:200;
codeLengths         = codeLengths(:);
LcodeLengths        = length(codeLengths);

pDPMp               = zeros(LcodeLengths,trials);
iDPMp               = zeros(LcodeLengths,trials);
prDPMp              = zeros(LcodeLengths,trials);
irDPMp              = zeros(LcodeLengths,trials);

xopt11              = [];
xopt126             = [];

%% Binary PSL
%% Part (a)
for k = 1 : trials
    for i = 1 : LcodeLengths
        N               = codeLengths(i);
        xR              = mcode( 8 , N ,0 );
        xR              = exp(1i * floor(angle(xR(1:N))/(2*pi/L))*(2*pi/L)); 
        xlp             = lpDPM_v6(xR,P,thr,L);
        [ xDPMp , ~]    = dpm_v4( xlp, L,thr,1, 0);
        [ pDPMp(i,k),iDPMp(i,k),prDPMp(i,k),irDPMp(i,k) ]  = pslisl(xDPMp);
        

        clc, disp([num2str(i*k/(trials*LcodeLengths)*100),' %'])
        
    end
end


pMPS = zeros(1,105);
pMPS(1:5) = 1;
pMPS(7) = 1;
pMPS(11) = 1;
pMPS(13) = 1;
pMPS(6) = 2;
pMPS(8:10) = 2;
pMPS(12) = 2;
pMPS(14:21) = 2;
pMPS(28) = 2;
pMPS(22:27) = 3;
pMPS(25) = 2;
pMPS(29:48)= 3;
pMPS(51) = 3;
pMPS(49) = 4;
pMPS(50) = 4;
pMPS(52:82) = 4;
pMPS(83:105) = 5;
prMPS = 20*log10((pMPS./(1:105)));


pDPMp               = min(pDPMp,[],2);
iDPMp               = min(iDPMp,[],2);
prDPMp              = min(prDPMp,[],2);
irDPMp              = min(irDPMp,[],2);

% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
% plot
figure; 
plot(codeLengths,prDPMp,'k-','MarkerSize', 12)
hold on
plot(2:105,prMPS(2:end),'r:','MarkerSize', 12)
axis('tight')
xlabel('N')
ylabel('PSLR(dB)')
legend('DPM','MPS','location','best')
grid on


figure; 
plot(codeLengths,pDPMp,'k.-','MarkerSize', 12)
hold on
plot(2:105,pMPS(2:end),'r.:','MarkerSize', 12)
axis('tight')
xlabel('N')
ylabel('PSL')
legend('DPM','MPS','location','best')
grid on
drawnow

% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%% Part (b)
psl11       = inf;
while psl11 >= 2
    xR11            = mcode( 15 , 11 ,0 );
    xlp             = lpDPM_v6(xR11,P,thr,L);
    xopt11          = dpm_v4( xlp, L,thr,1, 0);
    psl11           = pslisl(xopt11);    
end        
if ~isempty(xopt11)
    figure;
    plot(abs(xcorr(xR11)),':gr')
    hold on
    plot(abs(xcorr(xopt11)),'k')
    xlabel('shift(k)')
    ylabel('Correlation Level')    
    legend('Random Code','DPM(P), M = 2')
    grid on
    box on
    axis('tight')
    drawnow
end
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
%% Part (c)
psl126       = inf;
while psl126 >= 9
    xR126           = mcode( 15 , 126 ,0 );
    xlp             = lpDPM_v6(xR126,P,thr,L);
    xopt126         = dpm_v4( xlp, L,thr,1, 0);
    psl126          = pslisl(xopt126);    
end        
if ~isempty(xopt126)
    figure;
    plot(abs(xcorr(xR126)),':gr')
    hold on
    plot(abs(xcorr(xopt126)),'k')
    xlabel('shift(k)')
    ylabel('Correlation Level')    
    legend('Random Code','DPM(P), M = 2')
    grid on
    box on
    axis('tight')
    drawnow
end