function [ xout , o , t] = dpm_v4( x0, L,thr,theta, plt)
% This code was downloaded from radarmimo.com
% Mohammad Alaee, 26.09.2016
% mmalaee@yahoo.com

if ~exist('x0','var')
    rng(1)
    x0       = mcode(8,64);
    
end
if ~exist('L','var')
   L    = 256;
end
if ~exist('thr','var')
    thr      = 1e-5;
end
if ~exist('theta','var')
    theta    = 0;
end
if ~exist('plt','var')
    plt  = 0;
end



% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
x0          = x0(:);
N           = length(x0);
x0          = exp(1i * floor(angle(x0(1:N))/(2*pi/L))*(2*pi/L)); % if phase
x           = x0;
if L <= 2
    x       = real(ceil(x0)); x(find(real(x)==0,N)) = -1;
end
N           = length(x);
[ p1,i1,~,~ ] = pslisl( x );
ot1     = theta * p1^2 + (1-theta) * i1;
o(1)      = ot1;

obcnt   = 1;
cnd     = 1;
tic
while (cnd > 0 && obcnt < 1e5)
    for d = 1 : N
        if d == 1
            if L <= 2
                [ a_dk,c_dk ] = mabcbin( x,d );
                X1          = [a_dk,c_dk];
            else
                [ a_dk,b_dk,c_dk ] = mabc( x,d );
                X1          = [a_dk,c_dk,b_dk];
            end
        else
            if L <= 2
                [ a_dk,c_dk ] = mabcbin_v2( x,d ,a_dk,c_dk );
                X1          = [a_dk,c_dk];
            else
                [ a_dk,b_dk,c_dk ] = mabc_v2( x,d ,a_dk,b_dk,c_dk);
                X1          = [a_dk,c_dk,b_dk];
            end
        end
        Y           = (fft(X1.',L));
        Y1          = abs(Y).^2;
        Ytemp       = sum(Y1,2);
        Y2          = repmat(Ytemp,1,N-1);
        Omega       = theta * Y1 + (1 - theta) * Y2;
        mYobj       = max(Omega,[],2);
        [~,iy]      = min(mYobj);
        phf1est     = 2*pi*(iy-1)/L;
        if phf1est > pi
            phf1est = phf1est - 2*pi;
        end
        x(d)        = exp(1i * phf1est);
        
    end
    [ PSL_new,ISL_new ] = pslisl( x );
    o(end+1)    = theta * PSL_new^2 + (1 - theta) * ISL_new;
    obcnt       = obcnt + 1;
    if (o(end-1) - o(end)) < thr
        break
    end
end
t = toc;
xout    = x;
if L <= 2
    xout = real(xout);
end


if plt == 1
    rx1     = abs(xcorr(x0));
    rx3     = abs(xcorr(x));
    plot(rx1);
    hold on
    plot(rx3);
    axis('tight');
    drawnow
end
% figure; plot(((obj)))
if nargout == 0

    MarkerSize = 20;

    figure; 
    plot(10*log10((o)),'m^-');
    xlabel('iteration')
    ylabel('objective (dB)')
    grid on
    box on
    
    figure; hold on
    
    plot(10*log10(abs(xcorr(x0))/N),'b.-','MarkerSize',MarkerSize,'MarkerIndices',1:5:2*N-1);
    plot(10*log10(abs(xcorr(x))/N),'m^-','MarkerSize',MarkerSize,'MarkerIndices',1:5:2*N-1);
    ylim([-20*log10(2*sqrt(N)),0])
    box on
    grid on
    legend('Initial Sequence','Obtained Sequence','location','best')
    xlabel('shift (k)')
    ylabel('Correlation Level (dB)')
    axis 'tight'
    [psl_x,isl_x] = pslisl(x)
    xout = [];
end